Attribute VB_Name = "DBaseBas"
Option Explicit

'--------------------------------------------------------------------------
'   PUBLIC CONSTANTS
'--------------------------------------------------------------------------

'   Validation Rules
'   Used by DbaseObj.xValidate
Public Const VRULE_ISNOTNULL = 1
Public Const VRULE_ISNOTZERO = 2
Public Const VRULE_ISNUMERIC = 3
Public Const VRULE_ISNOTDECIMAL = 11
Public Const VRULE_ISDATE = 13
Public Const VRULE_ISINLIST = 12
Public Const VRULE_ISPOSITIVE = 4
Public Const VRULE_ISNEGATIVE = 5
Public Const VRULE_ISMIN_LEN = 6
Public Const VRULE_ISMAX_LEN = 7
Public Const VRULE_ISEXACT_LEN = 10
Public Const VRULE_ISMIN_VAL = 8
Public Const VRULE_ISMAX_VAL = 9

'--------------------------------------------------------------------------
'   PUBLIC STRUCTURES
'--------------------------------------------------------------------------

'   Used in Column Type
Public Type RuleType
    iRule As Integer                    ' A specific rule (see constants)
    lValue As Long                      ' Value associated with the rule
End Type

'   Used in extRecordset Type
Public Type IndexType
    bUnique As Boolean                  ' Whether this index is unique
    saField() As String                 ' The names of the fields in the index
    iNumFields As Integer               ' Number of fields in this index
    sName As String                     ' A unique name for this index
End Type

'   Used in extRecordSet Type
Public Type ColumnType
    taRule() As RuleType                ' Validation rules for this column
    iNumRules As Integer
    sField As String                    ' The field in the table used by column
    sName As String                     ' The name of the column
    sList As String                     ' An extractable list of possible values
    sValidList As String                ' An extractable list of valid values
    sDefault As String                  ' The default to set the column to in Addnew
End Type

'   Used in DBaseObj class
Public Type extRecordSetType
    tRecordset As Recordset             ' The actual set of records
    sName As String                     ' The name of the open table
    sSQL As String                      ' The SQL statement that defines recordset
                                        ' This is only the SELECT FROM block
    iNumKeys As Integer                 ' The max number of keys allowed in a sort
    sFindCriteria As String             ' The current find criteria (SQL: WHERE)
    sSngFindCriteria As String          ' The single find criteria (SQL: WHERE)
    sRequiredFind As String             ' The required SQL: WHERE for this recordset
    sSortCriteria As String             ' The current sort criteria (SQL: ORDER BY)
    sSortFields As String               ' The Sortable fields listed in Extractable format
    sFindFields As String               ' The find fields listed in Extractable format
    
    taColumn() As ColumnType            ' The columns defined
    iNumColumns As Integer              ' The number of columns defined
    iCurColumn As Integer               ' The currently selected column
    
    taIndex() As IndexType              ' The indeces defined
    iNumIndeces As Integer              ' The number of indeces
    iCurIndex As Integer                ' The currently selected index
End Type
