VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ExtractObj"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------------------------------
'   CONSTANTS
'----------------------------------------------------------------------------------

Private Const OBJ_NAME = "ExtractObj"

'----------------------------------------------------------------------------------
'   OBJECTS
'----------------------------------------------------------------------------------

' None

'----------------------------------------------------------------------------------
'   STRUCTURES
'----------------------------------------------------------------------------------

' None

'----------------------------------------------------------------------------------
'   VARIABLES
'----------------------------------------------------------------------------------

Private psaList() As String             ' A one or two dimensional list of strings
Private piNumIndeces As Integer         ' Size of first index
Private piNumValues As Integer          ' Size of second index

'   giNumIndeces
'   PURPOSE:
'       - Returns the value of the number of indeces
'   PARAMETERS:
'       - None
'   RETURNS:
'       - (integer)
'           - The number of indeces
Public Property Get giNumIndeces%()
    giNumIndeces = piNumIndeces
End Property


'   giNumValues
'   PURPOSE:
'       - Returns the value of the number of values
'   PARAMETERS:
'       - None
'   RETURNS:
'       - (integer)
'           - The number of values
Public Property Get giNumValues%()
    giNumValues = piNumValues
End Property



'   gsaList
'   PURPOSE:
'       - Returns the value in List(Index1, Index2)
'   PARAMETERS:
'       - Index1 (integer)
'       - Index2 (integer)
'           - The indeces to use in List
'   RETURNS:
'       - (string)
'           - The value at location (Index1, Index2)
Public Function gsaList$(riIndex1%, riIndex2%)
    gsaList = psaList$(riIndex1, riIndex2)
End Function

'   gsValue (Let)
'   PURPOSE:
'       - Reads a string and fills the given list with the data found
'       - Format is as follows:
'
'       (X) '?' <item> ? <item> ? <item> ? ...
'           where ? is any character selected by list maker
'           where X is the number of indeces to create in the list
'       <item> ? <item> ? <item> ? ...
'           where ? is the delimator provided in parameters
'           or the default value '|' if no delimator given

'   PARAMETERS:
'       - Text (byval string)
'           - The text string with the information to extract
'   RETURNS:
'       - None
Public Property Let gsValue(ByVal vsText$)
    Dim sDelimator$
    Dim iCurIndex%
    
    vsText = Trim$(vsText)
    
'   Determine the indeces
    If ((Mid$(vsText, 1, 1) = "(") And (Mid$(vsText, 3, 1) = ")")) Then
        piNumIndeces = Val(Mid$(vsText, 2, 1))
        vsText = Trim$(Mid$(vsText, 4))
    Else
        piNumIndeces = 1
    End If

'   Determine the delimator
    If ((Mid$(vsText, 1, 1) = "'") And (Mid$(vsText, 3, 1) = "'")) Then
'       Default to first character in string if no delimator given
        sDelimator = Mid$(vsText, 2, 1)
        vsText = Mid$(vsText, 4)
    Else
'       Default to '|'
        sDelimator = "|"
    End If
        
    vsText = Trim$(vsText)
    iCurIndex = piNumIndeces
    piNumValues = 0
    Do While (vsText <> "")
        If InStr(vsText, sDelimator) Then
'           A deliminator was found
            iCurIndex = iCurIndex + 1
            If (iCurIndex > piNumIndeces) Then
                iCurIndex = 1
                piNumValues = piNumValues + 1
                ReDim Preserve psaList$(1 To piNumIndeces, 1 To piNumValues)
            End If
            psaList$(iCurIndex, piNumValues) = Trim$(Left$(vsText, InStr(vsText, sDelimator) - 1))
                        
            vsText = Trim$(Mid$(vsText, InStr(vsText, sDelimator) + Len(sDelimator)))
        Else
'           No deliminator found, the remaining must be the last value
            iCurIndex = iCurIndex + 1
            If (iCurIndex > piNumIndeces) Then
                iCurIndex = 1
                piNumValues = piNumValues + 1
                ReDim Preserve psaList$(1 To piNumIndeces, 1 To piNumValues)
            End If
            psaList$(iCurIndex, piNumValues) = Trim$(vsText)
            
            vsText = ""
        End If
    Loop
End Property









