Attribute VB_Name = "Goodies"
Option Explicit

Public Const OBJ_NAME = "Goodies"

Private psErrorLog$         ' Contains the filename of the error log
Private psIniFile$          ' Contains the filename of the ini file
Public gsMsg$               ' A general purpose temporary string

Declare Function GetWindowsDirectory Lib "Kernel" (ByVal P$, ByVal s%) As Integer
Declare Function GetSystemDirectory Lib "Kernel" (ByVal P$, ByVal s%) As Integer

Declare Function FreeModule% Lib "Kernel" (ByVal hModule As Integer)

Public Const HWND_TOPMOST = -1

Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)

Declare Function BitBlt Lib "GDI" (ByVal destDC%, ByVal X%, ByVal Y%, ByVal w%, ByVal h%, ByVal srchDC%, ByVal srcX%, ByVal srcY%, ByVal rop&) As Integer
Declare Function StretchBlt Lib "GDI" (ByVal destDC%, ByVal X%, ByVal Y%, ByVal w%, ByVal h%, ByVal srchDC%, ByVal srcX%, ByVal srcY%, ByVal srcW%, ByVal srcH%, ByVal rop&) As Integer

Global Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Global Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest
Global Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Global Const SRCINFUNCTIONST = &H660046       ' (DWORD) dest = source XOR dest
Global Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Global Const NOTSRCCOPY = &H330008      ' (DWORD) dest = (NOT source)
Global Const NOTSRCERASE = &H1100A6     ' (DWORD) dest = (NOT src) AND (NOT dest)
Global Const MERGECOPY = &HC000CA       ' (DWORD) dest = (source AND pattern)
Global Const MERGEPAINT = &HBB0226      ' (DWORD) dest = (NOT source) OR dest
Global Const PATCOPY = &HF00021 ' (DWORD) dest = pattern
Global Const PATPAINT = &HFB0A09        ' (DWORD) dest = DPSnoo
Global Const PATINFUNCTIONST = &H5A0049       ' (DWORD) dest = pattern XOR dest
Global Const DSTINFUNCTIONST = &H550009       ' (DWORD) dest = (NOT dest)
Global Const BLACKNESS = &H42&  ' (DWORD) dest = BLACK
Global Const WHITENESS = &HFF0062       ' (DWORD) dest = WHITE

Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer
Declare Function GetCurrentTime Lib "User" () As Long

Type XYType
  X As Integer
  Y As Integer
End Type

Declare Sub GetCursorPos Lib "User" (lpPoint As XYType)
'   Returns the window that currently occupies that point
Declare Function WindowFromPoint% Lib "User" (ByVal lpPointY%, ByVal lpPointX%)

Public Const SW_SHOWNOACTIVATE = 4
Declare Function ShowWindow% Lib "User" (ByVal hWnd%, ByVal nCmdShow%)
'   RemoveSpaces
'   PURPOSE:
'       - Removes the whitespace from the given text
'       - Whitespace consists of SPACE, TAB, CR, and LF
'   PARAMATERS:
'       - Text (byval string)
'           - The text to remove the whitespace from
'   RETURNS:
'       - (string)
'           - The text without the whitespace
Function RemoveSpaces$(ByVal vsText$)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".RemoveSpaces"
    
'   Remove all spaces from the text given
    
    Dim n%
    
'   Remove spaces
    vsText = UCase$(Trim$(vsText))
    n = InStr(vsText, " ")
    Do While (n > 0)
        vsText = Left$(vsText, n - 1) & Mid$(vsText, n + Len(" "))
        n = InStr(vsText, " ")
    Loop
    
'   Remove tabs
    vsText = UCase$(Trim$(vsText))
    n = InStr(vsText, vbTab)
    Do While (n > 0)
        vsText = Left$(vsText, n - 1) & Mid$(vsText, n + Len(vbTab))
        n = InStr(vsText, vbTab)
    Loop
    
'   Remove carriage returns
    vsText = UCase$(Trim$(vsText))
    n = InStr(vsText, vbCr)
    Do While (n > 0)
        vsText = Left$(vsText, n - 1) & Mid$(vsText, n + Len(vbCr))
        n = InStr(vsText, vbCr)
    Loop
    
'   Remove Linefeeds
    vsText = UCase$(Trim$(vsText))
    n = InStr(vsText, vbLf)
    Do While (n > 0)
        vsText = Left$(vsText, n - 1) & Mid$(vsText, n + Len(vbLf))
        n = InStr(vsText, vbLf)
    Loop
    
    RemoveSpaces = vsText
    
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function




'   Slice
'   PURPOSE:
'       - Removes the text from Start to End (inclusive)
'   PARAMETERS:
'       - Text (string)
'           - The text to retrieve the slice from
'       - Start (integer)
'           - The start of the slice
'       - End (integer)
'           - The end of the slice
'   RETURNS:
'       - (string)
'           - The retrieved slice
Public Function Slice$(rsText$, riStart%, riEnd%)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".Slice"
    
    Slice = Mid$(rsText$, riStart, riEnd - riStart + 1)
    
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function

'   FileExists
'   PURPOSE:
'       - Determines if a file already exists by creating it and seeing
'         if an error occurs
'   PARAMETERS:
'       - FileName (string)
'           - The file to check
'   RETURNS:
'       - (boolean)
'           - TRUE : The file exists
'           - FALSE: The file doesn't exist
Function FileExists(rsFileName$) As Boolean
    Dim iX%
    iX = FreeFile

    On Error Resume Next
    Open rsFileName For Input As iX
    If Err = 0 Then
        FileExists = True
    Else
        FileExists = False
    End If
    Close iX
End Function

'   ExitProg
'   PURPOSE:
'       - This routine is called when a fatal user-defined error occurs
'       - It will close down the system and declare an error (if given one)
'   PARAMETERS:
'       - CurrentRoutine (optional string)
'           - The Routine from which this routine was called
'       - Error (optional string)
'           - an error message
'   RETURNS:
'       - None
Public Sub ExitProg(Optional rvntCurrentRoutine, Optional rvntError)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".ExitProg"
    
    If Not IsMissing(rvntError) Then
        If (rvntError <> "") Then
            gsMsg = "Program has halted prematurely...  "
            MsgBox gsMsg & CStr(rvntError)
            If IsMissing(rvntCurrentRoutine) Then
                Call goError.xLog(-1, "(No routine name given)", gsMsg & CStr(rvntError))
            Else
                Call goError.xLog(-1, CStr(rvntCurrentRoutine), gsMsg & CStr(rvntError))
            End If
        End If
    End If
    
    End
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub




'   SystemDirectory
'   PURPOSE:
'       - Returns the system directory path
'   PARAMETERS:
'       - None
'   RETURNS:
'       - (string)
'           - The system path
Function SystemDirectory$()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".SystemDirectory"
    
    Dim sPath$: sPath = String(145, vbNullChar)
    SystemDirectory = Left$(sPath, GetSystemDirectory(sPath, Len(sPath)))
    
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function






'   WindowsDirectory
'   PURPOSE:
'       - Returns the windows directory path
'   PARAMETERS:
'       - None
'   RETURNS:
'       - (string)
'           - The windows path
Function WindowsDirectory$()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".WindowsDirectory"
    
    Dim sPath$: sPath = String(145, vbNullChar)
    WindowsDirectory = Left(sPath, GetWindowsDirectory(sPath, Len(sPath)))
    
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function



'   GetSetForms
'   PURPOSE:
'       - Provides a method of querying the status of a window without
'         actually activating it (activation causes methods to run)
'   PARAMETERS:
'       - Options (string)
'           - The operation to perform on the windows
'       - Value (optional string)
'           - The windows to perform the change on
'           - All window names with '-' preceding them are ignored when
'             performing the operation
'           - If the Value is missing, then all windows are operated on
'   RETURNS:
'       - (boolean)
'           - Returns an answer to the operation given
Public Function GetSetForms(rsOption$, Optional rvntValue) As Boolean
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".GetSetForms"
    
    Dim n%, bFound%
    
    GetSetForms = False
    For n = 0 To Forms.Count - 1
        If (n > Forms.Count - 1) Then Exit For
        bFound = True 'Do it by default
        If Not IsMissing(rvntValue) Then 'Parameter present
            If (InStr(CStr(rvntValue), "-" & Forms(n).Name) <> 0) Then
'               This is a form we are NOT to operate on
                bFound = False
                                
'           If it is numeric it is to be considered not the name of a form
            ElseIf (InStr(CStr(rvntValue), Forms(n).Name) <> 0) Then
                bFound = True
            End If
        End If
        
        If bFound Then 'Yep: do it to this one...
            Select Case UCase$(rsOption)
                Case "VISIBILTY"
                    Forms(n).Visible = Val(rvntValue)
                Case "ISMINIMIZED"
                    GetSetForms = (Forms(n).WindowState = 1)
                Case "ISLOADED"
    '               GetSetForms set at bottom of select statement
                Case "UNLOAD"
                    Unload Forms(n)
                    n = n - 1
                Case "NORMALIZE"
                    If (Forms(n).WindowState = 1) Then Forms(n).WindowState = 0
                Case "SETFOCUS"
    '               Don't want to set focus to a minimized form, so normalize first
                    If (Forms(n).WindowState <> 0) Then Forms(n).WindowState = 0
                    Forms(n).SetFocus
                Case Else
                    ExitProg sCurrentRoutine, "Bad call, unknown option: '" & Format$(rsOption) & "'."
            End Select
            GetSetForms = True
            DoEvents
        End If
    Next n
    
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function



'   Enumerate
'   PURPOSE:
'       - Returns a new extractable listing created from the given
'       - The new listing has two columns with the second being a numerical
'         enumeration of the values given
'   PARAMETERS:
'       - List (string)
'           - A single column extractable listing
'   RETURNS:
'       - (string)
'           - A double column extractable listing
Public Function Enumerate$(rsList$)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".Enumerate"

    Dim tReturn As ExtractObj: Set tReturn = New ExtractObj
    Dim sBuffer$
    Dim n%
    
    tReturn.gsValue = rsList
    
    If (tReturn.giNumIndeces > 1) Then
        Enumerate = rsList
        Exit Function
    End If
    
    sBuffer = "(2) '|' "
    For n = 1 To tReturn.giNumValues
        sBuffer = sBuffer & tReturn.gsaList(1, n) & " | " & Format$(n) & " | "
    Next n

    Enumerate = LeftChop$(sBuffer, 3)

    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function

'   LeftChop
'   PURPOSE:
'       - Chops off the given number of characters off the given string
'       - Returns an empty string is the string length < given value
'   PARAMETERS:
'       - String (string)
'       -
'   RETURNS:
'       - (string)
'           - The remaining portion of the string
Public Function LeftChop$(rsString$, riChop%)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = OBJ_NAME & ".goIni.xset"
    
    If (Len(rsString) < riChop) Then
        LeftChop = ""
    Else
        LeftChop = Left$(rsString, Len(rsString) - riChop)
    End If

    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function
