VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IniObj"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------------------------------
'   CONSTANTS
'----------------------------------------------------------------------------------

Private Const OBJ_NAME = "IniObj"

'----------------------------------------------------------------------------------
'   OBJECTS
'----------------------------------------------------------------------------------

' None

'----------------------------------------------------------------------------------
'   STRUCTURES
'----------------------------------------------------------------------------------

' None

'----------------------------------------------------------------------------------
'   VARIABLES
'----------------------------------------------------------------------------------

Private psFileName As String                ' Name of INI file
'   xSet
'   PURPOSE:
'       - Set the given item in the applications ini file
'       - Both the Section and Key are used to locate the proper location
'   PARAMETERS:
'       - Section (string)
'           - The section under which to place the new data
'       - Key (string)
'           - The key value to place the data in as
'       - Value (string)
'           - The value of the new data
'   RETURNS:
'       - None
Public Sub xSet(rsSection$, rsKey$, rsValue$)
    Call SaveSetting(psFileName, rsSection$, rsKey$, rsValue$)
End Sub



'   xGet
'   PURPOSE:
'       - Retrieves the given item from the applications ini file
'       - Both the Section and Key are used to locate the proper data
'   PARAMETERS:
'       - Section (string)
'           - The section to search for the key value
'       - Key (string)
'           - The key value to look up
'       - Default (string)
'           - This value is returned if no data is found
'   RETURNS:
'       - (string)
'           - The data located under the given Section, and Key
Public Function xGet$(rsSection$, rsKey$, rsDefault$)
    Dim sTemp$
    sTemp$ = GetSetting(psFileName, rsSection$, rsKey$, rsDefault$)
    xGet = "" & sTemp$
End Function





'   xInitialize
'   PURPOSE:
'       - Sets the name of the ini file for later use
'       - NOTE: If not performed, the ini object will default to 'EXEname'.ini
'   PARAMETERS:
'       - Name (string)
'           - The name of the file
'   RETURNS:
'       - None
Public Property Let gsFileName(rsName$)
    psFileName = rsName
End Property


Private Sub Class_Initialize()
    psFileName = App.EXEName & ".ini"
End Sub



